;****************************************************************************
;*                                                                          *
;*                          Vitus Graphic Interface                         *
;*                                Version 2.5                               *
;*           Easy, event driven, object oriented graphic interface          *
;*                       for Turbo Pascal 5.5 or higher                     *
;*                 Copyright (c) by Vitus B.Wagner, 1991-1993               *
;*                                                                          *
;*                              VGILOW.PAS                            *
;*                                MOUSE.ASM                             *
;*                      ஢ ࠡ                         *
;****************************************************************************
.MODEL TPASCAL
TPoint Struc
        X DW  ?
        Y DW  ?
       ends
TCursorShape STRUC
        X DW ?
        Y DW ?
        CursorMask DW 16 DUP (?)
        ScreenMask DW 16 DUP (?)
       ends
;饭  ⠡ 㠫 ⮤ 
IFDEF Pascal70
 TCursor_Done EQU 8
 TCursor_Show EQu 12
 TCursor_Hide EQU 16
 TCursor_Move EQU 20
 TCursor_GetX EQU 24
 TCursor_GetY EQU 28
 TCursor_SetShape EQU 32
 TCursor_VideoModeChanged EQU 36
ELSE
 TCursor_Done EQU 4
 TCursor_Show EQu 8
 TCursor_Hide EQU 12
 TCursor_Move EQU 16
 TCursor_GetX EQU 20
 TCursor_GetY EQU 24
 TCursor_SetShape EQU 28
 TCursor_VideoModeChanged EQU 32
ENDIF
 LOCALS @@
 .Data
   EXTRN Cursor:DWord
 .CODE
 EXTRN PutEvent:Far
 PUBLIC MouseHandler,SVGAMouseHandler,InitMouse,DoneMouse,SetMouseRange
 PUBLIC TMouseCursor@SetShape,TMouseCursor@Show,TMouseCursor@Hide,TMouseCursor@Move
 PUBLIC TMouseCursor@GetX,TMouseCursor@GetY
;************** ⮤ ꥪ TMouseCursor *******************************
;Function GetX:integer - 頥 ⥪ X-न
TMouseCursor@GetX proc far Self:Dword
  mov ax,3
  Int 33H
  Mov AX,cx
  Ret
endp
;Function GetY:integer - 頥 ⥪ Y-न
TMouseCursor@GetY proc far Self:Dword
  mov ax,3
  Int 33H
  Mov AX,dx
  Ret
endp
;Procedure Move(X,Y:Integer) - ६頥    
TMouseCursor@Move Proc Far XX:Word,YY:Word,Self:Dword
  Mov ax,4
  Mov cx,XX;
  Mov Dx,YY;
  Int 33h;
  Ret
 endp
;Procedure SetShape(var AShape:TCursorShape) - ⠭  
TMouseCursor@SetShape Proc Far AShape:DWord,Self:DWord
 Push DS
 LDS SI,AShape
 Cld
 LES Di,SElf
 Add di,2
 mov cx,34
 rep movsw
 POP DS
 Mov DI,Word Ptr Self
 ADD DI,2
 Mov Bx,Es:[DI].TCursorShape.X;
 Mov Cx,Es:[DI].TCursorShape.Y;
 MOV DX,DI
 Add Dx,4
 Mov AX,9
 Int 33h
 Ret
endp
;Procedure Show - 뢠  
TMouseCursor@Show Proc Far Self:Dword
 Mov AX,1
 Int 33H
 Ret
Endp
;Procedure Hide - 뢠  
TMouseCursor@Hide Proc Far Self:Dword;
 Mov AX,2
 Int 33H
 Ret
endp
;************ 㡮 ७ 楤 *************************
;ࠡ稪 ᮡ  
MouseHandler Proc far
                Push AX
                Mov Ax,Seg @DATA
                Mov Ds,Ax
                POP AX
                MOV BH,0FFH
                Test al,7eH
                jz @@PutEvent
                Dec BH
                Test Al,2aH
                jnz @@PutEvent
                DEC BH
@@PutEvent:     Push BX
                Push CX
                Push DX
                call Far Ptr PutEvent
                Ret
endp
;ࠡ稪 ᮡ  ,  㬥饩 ᮢ 
SVGAMouseHandler Proc far
                Pushf
                cli
                Push AX
                Mov Ax,Seg @DATA
                Mov Ds,Ax
                MOV BH,0FFH
                POP AX
                Test al,7eH
                jz @@PutEvent
                Dec BH
                Test Al,2AH
                jnz @@PutEvent
                DEC BH
@@PutEvent:     Push CX
                Push DX
                Push BX
                Push CX
                Push DX
                Push cs
                call Near Ptr PutEvent
                LES DI,Cursor
                Push ES
                Push DI
                MOV DI,ES:[DI]
                Call DWord Ptr [DI].TCursor_Move
                popf
                Ret
endp

;饭 ࠡ稪 ᮡ⨩. 뢠  TMouseCursor.Done
DoneMouse Proc far
          Mov ax,0CH
          mov cx,0
          int 33H
          Ret
          endp
;Function InitMouse:Boolean - 뢠  TMouseCursor.Init
;頥 False, ᫨ ࠩ   㦥
InitMouse Proc Far Handler:DWord
          Mov ax,3533H
          int 21H
          mov ax,es
          or ax,bx
          jz @@Fail
          sub ax,ax
          int 33H
          or ax,ax
          jz @@Fail
          LES DX,Handler
          Mov cx,7FH
          mov ax,0cH
          int 33H
          mov al,1
          ret
@@fail:   sub al,al
          ret
endp;
;⠭ । न ६饭 
SetMouseRange Proc Far X1,Y1,X2,Y2:Word;
         Mov AX,7
         Mov CX,X1
         Mov DX,X2
         Int 33H
         Mov AX,8
         Mov CX,Y1
         Mov DX,Y2
         Int 33H
         ret
        endp
end
